#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <sys/dispatch.h>

/*      .  . */
typedef struct _pulse msg_header_t;

/*          */
typedef struct _MsgBuf {
    msg_header_t	hdr;
    char		*	Buffer;
} MsgBuf_t;

int main() {
name_attach_t  * NameServer;
MsgBuf_t MsgBuf;
int rcvid;
char BufReply[100];

/*     /dev/name/global/MyService  */
if (!(NameServer = name_attach(NULL, "MyService", NAME_FLAG_ATTACH_GLOBAL)))
return EXIT_FAILURE;

/*        */
while (1) {
  if ((rcvid = MsgReceive(NameServer->chid, &MsgBuf, sizeof MsgBuf, NULL)) == -1 )  {
    printf("    MyService   \n");
    fflush(stdout);
    break;
  }

  if (!rcvid)   {					//   
    switch (MsgBuf.hdr.code) {
      case _PULSE_CODE_DISCONNECT:
        /*       _NTO_CHF_DISCONNECT,   */
        /*        .        */
        /*         ,         */
        /*        "".                                                       */
        ConnectDetach(MsgBuf.hdr.scoid);
      break;

      case _PULSE_CODE_UNBLOCK:
        /*    ,     Reply.       */
        /*    - ,   ( )               */
        /*    ,  -    -                */
        /*    !     MsgBuf.hdr.value  rcvid     */
        MsgReply(MsgBuf.hdr.value.sival_int, EAGAIN, NULL, 0);
      break;
  
      default:  break;
    }
    continue;                                                      //       
  }

  /*           */
  /*    /.  .                           */
  if (MsgBuf.hdr.type >= _IO_BASE  &&  MsgBuf.hdr.type <= _IO_MAX) {
    MsgError(rcvid, ENOSYS);
    continue;
  }

  /*     -   . .    */
  if (MsgBuf.hdr.type <=0x50001  ||  MsgBuf.hdr.type>=0x500ff)  {
    printf("        %#x\n", MsgBuf.hdr.type);
    strcpy(BufReply, "?  ???");
  }
  else {
    printf("  : \"%s\"\n", MsgBuf.Buffer);
    strcpy(BufReply, ",  , ");
  }
  MsgReply(rcvid, EOK, BufReply, strlen(BufReply)+1);

}                                                                            //     

/*          */
name_detach(NameServer, 0);

return EXIT_SUCCESS;
}


