#include <errno.h>
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/iofunc.h>
#include <sys/dispatch.h>
#include <devctl.h>
#include <locale.h>

#include "/home/ZZZ/TESTS/MessagePassing/MessTest.h"

int PrivatHandler(message_context_t * ctp, int code, unsigned flags, void * handle);
char * IdLabelParse(int id);

static resmgr_connect_funcs_t	connect_funcs;				//    
static resmgr_io_funcs_t			io_funcs;						//    /
static iofunc_attr_t						attr;								//    

main (int args, char **argv)  {
resmgr_attr_t				resmgr_attr;		//     
dispatch_t					*dpp;				//    ,
															//   .
dispatch_context_t	*ctp;					//   ,   ,
														//    /
int								id;
int								result;
char BufferRec[100];
int rcvid;

setlocale(LC_CTYPE, "C-TRADITIONAL");

/*          */

/* ,     ... */

/*    */
if((dpp = dispatch_create()) == NULL) {
  printf("%s:    .\n", argv[0]);
  return EXIT_FAILURE;
}
/*     dpp     */

/*     */
memset(&resmgr_attr, 0, sizeof resmgr_attr);
resmgr_attr.nparts_max = 1;
resmgr_attr.msg_max_size = MESSIZE_MAX;
/*	     / (IOV)  1.	*/
/*       MESSIZE_MAX.		*/
/*       		*/

/*     */
iofunc_func_init(_RESMGR_CONNECT_NFUNCS, &connect_funcs,
		                  _RESMGR_IO_NFUNCS,				 &io_funcs);
/*      (),   	*/
/*     :	  								*/
/*																		  /.					*/
/*        		*/
/* iofunc_*_default().																											*/
/*    -  																					*/

/*      */
iofunc_attr_init(&attr, S_IFNAM | 0666, 0, 0);
attr.nbytes = MESSIZE_MAX+1;
/*      ,  .	*/
/* S_IFNAM ,    - Special named file;											*/
/*   666   ;															*/
/*            										*/

/*    */
if((id = resmgr_attach(dpp, &resmgr_attr, "/dev/MESSTEST/RM", _FTYPE_ANY, 0,
								 &connect_funcs, &io_funcs, &attr)) == -1) {
  printf("%s:     .\n", argv[0]);
  return EXIT_FAILURE;
}

/*  :       /dev/MESSTEST/RM		*/
/* *dpp  resmgr_attr -   ;					*/
/* /dev/MESSTEST/RM -    ;				*/
/* _FTYPE_ANY -     (  			*/
/*     );							*/
/*        ,   -			*/
/*    /dev/MESSTEST/RM;								*/
/* &connect_funcs	-    ;					*/
/* &io_funcs		-    /;				*/
/*  attr -     				*/

/*   ,   ,  	*/
/* -         PrivatHandler()	*/
if (message_attach (dpp, NULL, 0x5000, 0x5fff, &PrivatHandler, NULL) == -1 ) {
  printf("H     \n");
  return (EXIT_FAILURE);
}

//*    */
ctp = dispatch_context_alloc(dpp);
/*   ,    ,   		*/
/*   /,     , 			*/
/*       		*/

/*     							*/
while(1) {
  if((ctp = dispatch_block(ctp)) == NULL) {		//    
    printf(" \n");
    return EXIT_FAILURE;
  }
/*
printf("     %i \n",
ctp->resmgr_context.info.msglen);
*/
  result = dispatch_handler(ctp);				//   ,   
															//      / 
															//    
  if (result)
  printf("M      result=%i\n", result);
  fflush(stdout);

}
}

/****************************************************************************/
/*    , .. ,  			*/
/*    ,     message_attach()		*/
/*****************************************************************************/
int PrivatHandler(message_context_t * ctp, int code, unsigned flags, void * handle) {
char Buffer [MESSIZE_MAX];

printf("    %x  \"%s\"\n", code, IdLabelParse(code));
printf("B  : <<%s>>\n", (char *)(ctp->msg)+4);
fflush(stdout);

strcpy(Buffer, "K: ,  ");
MsgReply(ctp->rcvid, EOK, Buffer, sizeof(Buffer));

return (0);
}

/*****************************************************************/
/*            ,                       */
/*             */
/*****************************************************************/
char * IdLabelParse(int id) {
struct IdLabel_t Inventory;
int  i = 0;

while (IdLabel[i].id != id && i<ALLNUM_MYPROC) i++;
if (i==ALLNUM_MYPROC) return Anonimus; else return (IdLabel[i].name);
}

