#include <stdlib.h>
#include <stdio.h>
#include <inttypes.h>
#include <iostream.h>
#include <sys/neutrino.h>
#include <process.h>
#include <sys/syspage.h>

static double cycle2milisec ( uint64_t ccl ) {
   const static double s2m = 1.E+3;
   const static uint64_t cps = SYSPAGE_ENTRY( qtime )->cycles_per_sec;  // частота процессора:
   return (double)ccl * s2m / (double)cps; 
};

struct mbyte {
#pragma pack( 1 )
   uint8_t data[ 1024 * 1024 ];
#pragma pack( 4 )
};

int main( int argc, char *argv[] ) {
   mbyte *blk = NULL;
   if( argc > 1 && atoi( argv[ 1 ] ) > 0 ) {
      blk = new mbyte[ atoi( argv[ 1 ] ) ];
   };
   uint64_t t = ClockCycles();
   pid_t pid = fork();
   if( pid == -1 ) perror( "fork" ), exit( EXIT_FAILURE );
   if( pid == 0 ) exit( EXIT_SUCCESS );
   if( pid > 0 ) {
      waitpid( pid, NULL, WEXITED );
      t = ClockCycles() - t;
   };
   if( blk != NULL ) delete blk;
   cout << "Fork time: " << cycle2milisec( t ) << " msec. [" << t << " cycles]" << endl;    
   exit( EXIT_SUCCESS );
};

