#include <stdlib.h>
#include <stdio.h>
#include <inttypes.h>
#include <iostream.h>
#include <sys/neutrino.h>
#include <process.h>
#include <sys/syspage.h>

static double cycle2milisec ( uint64_t ccl ) {
   const static double s2m = 1.E+3;
   const static uint64_t cps = SYSPAGE_ENTRY( qtime )->cycles_per_sec;  // частота процессора:
   return (double)ccl * s2m / (double)cps; 
};

void workproc( int how = 1 ) {
   const int nsingl = 1000, msingl = 30;
   for( int j = 0; j < how; j++ )  // ... якобы вычисления
      for( uint64_t i = 0; i < msingl; i++ ) {
         for( uint64_t k = 0; k < nsingl; k++ ) k = ( k + 1 ) - 1; 
         sched_yield();
      };
}; 

int main( int argc, char *argv[] ) {
   int numpar = 1;
   if( argc > 1 && atoi( argv[ 1 ] ) > 0 ) numpar = atoi( argv[ 1 ] );
   uint64_t t = ClockCycles();
   for( int i = 0; i < numpar; i++ ) {
      pid_t pid = fork();
      if( pid == -1 ) perror( "fork" ), exit( EXIT_FAILURE );
      if( pid == 0 ) {
         workproc( 100 );
         exit( EXIT_SUCCESS );
      };
   };   
   for( int i = 0; i < numpar; i++ ) wait3( NULL, WEXITED, NULL );
   t = ClockCycles() - t;
   cout << "Forks scheduling time: " << cycle2milisec( t ) << " msec. [" << t << " cycles]" << endl;    
   exit( EXIT_SUCCESS );
};


