#include <stdlib.h>
#include <stdio.h>
#include <inttypes.h>
#include <iostream.h>
#include <sys/neutrino.h>
#include <pthread.h>
#include <sys/syspage.h>

static double cycle2milisec ( uint64_t ccl ) {
   const static double s2m = 1.E+3;
   const static uint64_t cps = SYSPAGE_ENTRY( qtime )->cycles_per_sec;  // частота процессора:
   return (double)ccl * s2m / (double)cps; 
};

void workproc( int how = 1 ) {
   const int nsingl = 1000, msingl = 30;
   for( int j = 0; j < how; j++ )  // ... якобы вычисления
      for( uint64_t i = 0; i < msingl; i++ ) {
         for( uint64_t k = 0; k < nsingl; k++ ) k = ( k + 1 ) - 1; 
         sched_yield();
      };
}; 

void* threadfunc ( void* data ) {
   workproc( 100 );
   pthread_exit( NULL );
};

int main( int argc, char *argv[] ) {
   int numpar = 1;
   if( argc > 1 && atoi( argv[ 1 ] ) > 0 ) numpar = atoi( argv[ 1 ] );
   pthread_t *tids = new pthread_t[ numpar ];
   uint64_t t = ClockCycles();
   for( int i = 0; i < numpar; i++ ) 
      pthread_create( &tids[ i ], NULL, threadfunc, NULL );   
   for( int i = 0; i < numpar; i++ ) pthread_join( tids[ i ], NULL );
   t = ClockCycles() - t;
   cout << "Threads scheduling time: " << cycle2milisec( t ) << " msec. [" << t << " cycles]" << endl;    
   exit( EXIT_SUCCESS );
};


