#include <stdlib.h>
#include <stdio.h>
#include <iostream.h>
#include <pthread.h>
#include "p4common.h"

void* threadfunc ( void* data ) {
   workproc( 1000 );
   pthread_exit( NULL );
};

int main( int argc, char *argv[] ) {
   int numpar = 1;
   if( argc > 1 && atoi( argv[ 1 ] ) > 0 ) numpar = atoi( argv[ 1 ] );
   pthread_t *tids = new pthread_t[ numpar ];
   _clockperiod clcold = setclock( argc > 2 ? atoi( argv[ 2 ] ) : 0 );   
   cout << "Rescheduling interval = " << sched_interval() << " msec." << endl;   
   uint64_t t = ClockCycles();
   for( int i = 0; i < numpar; i++ ) pthread_create( &tids[ i ], NULL, threadfunc, NULL );   
   for( int i = 0; i < numpar; i++ ) pthread_join( tids[ i ], NULL );
   t = ClockCycles() - t;
   cout << "Threads scheduling time: " << cycle2milisec( t ) << " msec. [" << t << " cycles]" << endl;    
   ClockPeriod( CLOCK_REALTIME, &clcold, NULL, 0 );      
   exit( EXIT_SUCCESS );
};

