#include <sys/syspage.h> 
#include "p4common.h"

double cycle2milisec ( uint64_t ccl ) {
   const static double s2m = 1.E+3;
   const static uint64_t cps = SYSPAGE_ENTRY( qtime )->cycles_per_sec;  // частота процессора:
   return (double)ccl * s2m / (double)cps; 
};

void workproc( int how = 1 ) {   // ... якобы вычисления
   const int nsingl = 30000;
   for( int j = 0; j < how; j++ )
     for( uint64_t k = 0; k < nsingl; k++ ) k = ( k + 1 ) - 1; 
}; 

_clockperiod setclock( int tick ) {
   _clockperiod res;
   ClockPeriod( CLOCK_REALTIME, NULL, &res, 0 );
   if( tick > 0 ) {
      _clockperiod clcnew = { tick * 1000, 0 };
      ClockPeriod( CLOCK_REALTIME, &clcnew, NULL, 0 );
   }; 
   return res;
};

double sched_interval( void ) {
   timespec interval;
   sched_rr_get_interval( 0, &interval );   
   return (double)interval. tv_nsec / 1000000.;
};

