#include <stdlib.h>
#include <inttypes.h>
#include <iostream.h>
#include <unistd.h>
#include <sched.h>
#include <sys/neutrino.h>

int main( int argc, char *argv[] ) {
   unsigned long N = 1000;
   if( argc > 1 && atoi( argv[ 1 ] ) > 0 ) N = atoi( argv[ 1 ] );
   pid_t pid = fork();
   if( pid == -1 ) cout << "fork error" << endl, exit( EXIT_FAILURE );
   uint64_t t = ClockCycles();
   for( unsigned long i = 0; i < N; i++ ) sched_yield();
   t = ClockCycles() - t;   
   delay( 200 );
   cout << pid << "\t: cycles - " << t << "; on sched - " << ( t / N ) / 2 << endl;
   exit( EXIT_SUCCESS );
};

