#include <stdlib.h>
#include <stdio.h>
#include <inttypes.h>
#include <iostream.h>
#include <unistd.h>
#include <pthread.h>
#include <errno.h>
#include <sys/neutrino.h>

unsigned long N = 1000;
static pthread_barrier_t bstart;

void* threadfunc ( void* data ) {
   pthread_barrier_wait( &bstart );
   uint64_t t = ClockCycles();
   for( unsigned long i = 0; i < N; i++ ) sched_yield();
   t = ClockCycles() - t;
   delay( 100 );
   cout << pthread_self() << "\t: cycles - " << t << "; on sched - " << ( t / N ) / 2 << endl;
   return NULL;
};

int main( int argc, char *argv[] ) {
   int opt, val; 
   while ( ( opt = getopt( argc, argv, "n:" ) ) != -1 ) {
      switch( opt ) {
         case 'n' :
            if( sscanf( optarg, "%i", &val ) != 1 )
               cout << "parse command line error" << endl, exit( EXIT_FAILURE );
            if( val > 0 ) N = val;
            break;
         default :
            cout << "parse command line failed" << endl, exit( EXIT_FAILURE );
            break;
       }
   };
   const int T = 2;
   pthread_t tid[ T ];
   if( pthread_barrier_init( &bstart, NULL, T ) != EOK )
      cout << "barrier init error", exit( EXIT_FAILURE );
   for( int i = 0; i < T; i++ )
      if( pthread_create( tid + i, NULL, threadfunc, NULL ) != EOK )
         cout << "thread create error", exit( EXIT_FAILURE );
   for( int i = 0; i < T; i++ ) pthread_join( tid[ i ], NULL );
   exit( EXIT_SUCCESS );
};

