#include <stdlib.h>
#include <stdio.h>
#include <inttypes.h>
#include <iostream.h>
#include <unistd.h>
#include <sched.h>
#include <sys/neutrino.h>

// пустые обработчики сигнала
static void nhand( int signo ) { };
static void qhand( int signo, siginfo_t* info, void* context ) { };

int main( int argc, char *argv[] ) {
   unsigned long N = 1000;
   bool que = false;
   int opt, val; 
   while ( ( opt = getopt( argc, argv, "n:q" ) ) != -1 ) {
      switch( opt ) {
         case 'n' :
            if( sscanf( optarg, "%i", &val ) != 1 )
               cout << "parse command line error" << endl, exit( EXIT_FAILURE );
            if( val > 0 ) N = val;
            break;
         case 'q' :
            que = true;
            break;
         default :
            cout << "parse command line failed" << endl, exit( EXIT_FAILURE );
            break;
       }
   };
   // установка обработчика сигнала
   sigset_t sig;
   sigemptyset( &sig ); 
   sigaddset( &sig, SIGUSR1 );  
   sigprocmask( SIG_UNBLOCK, &sig, NULL );           
   struct sigaction act;
   act.sa_mask = sig;
   act.sa_sigaction = qhand;
   act.sa_handler = nhand;
   act.sa_flags = que ? SA_SIGINFO : 0;
   if( sigaction( SIGUSR1 , &act, NULL ) < 0 ) cout << "set signal handler" << endl, exit( EXIT_FAILURE );
   pid_t pid = fork();
   if( pid == -1 ) cout << "fork error" << endl, exit( EXIT_FAILURE );
   pid_t  did = ( pid == 0 ? getppid() : pid );
   unsigned long i = 0; 
   uint64_t t = ClockCycles();
   while( true ) {
      kill( did, SIGUSR1 );
      if( ++i == N ) break;
      pause();
   };
   t = ClockCycles() - t;   
   cout << getpid() << " -> " << did << "\t: cycles - " << t << "; on signal - " << ( t / N ) / 2 << endl;
   exit( EXIT_SUCCESS );
};

