#include <stdio.h>
#include <iostream.h>
#include <signal.h>
#include <unistd.h>
#include <pthread.h>
#include <sys/neutrino.h>
#include <vector>

static void handler( int signo, siginfo_t* info, void* context ) {
   cout << "SIG = " << signo << "; TID = " << pthread_self()  << endl;
};

static void endhandler( int signo ) { };

const int SIGNUM = SIGRTMIN;
sigset_t sig;
struct threcord {
   int tid;
   bool noblock;
};
static vector<threcord> tharrey;

void* threadfunc ( void* data ) {
   sigset_t sigall; 
   sigfillset( &sigall ); 
   SignalProcmask( 0, 0, SIG_BLOCK, &sigall, NULL );
   sched_yield();
   tharrey[ (int)data ].noblock = ( SignalProcmask( 0, 0, SIG_UNBLOCK, &sig, NULL ) != -1 );   
   while( true ) {
      pause();
      tharrey[ (int)data ].noblock = !( SignalProcmask( 0, 0, SIG_BLOCK, &sig, NULL ) != 1 );
      bool nolast = false;
      for( vector<threcord>::iterator i = tharrey.begin(); i != tharrey.end(); i++ ) 
         if( nolast = i->noblock ) break; 
      if( nolast ) kill( getpid(), SIGNUM );
      else 
         for( vector<threcord>::iterator i = tharrey.begin(); i != tharrey.end(); i++ ) 
            i->noblock = ( SignalProcmask( 0, i->tid, SIG_UNBLOCK, &sig, NULL ) != -1 ); 
   };
};                    

int main() {
   signal( SIGINT, endhandler );
   sigemptyset( &sig );
   sigaddset( &sig, SIGNUM );
   sigprocmask( SIG_BLOCK, &sig, NULL ); 
   cout << "Process " << getpid() << ", waiting fot signal " << SIGNUM << endl;
   struct sigaction act;
   act.sa_mask = sig;
   act.sa_sigaction = handler;
   act.sa_flags = SA_SIGINFO;
   if( sigaction( SIGNUM, &act, NULL ) < 0 ) perror( "set signal handler: " ); 
   const int thrnum = 3;
   for( int i = 0; i < thrnum; i++ ) {
      threcord threc = { 0, false };
      pthread_create( &threc.tid, NULL, threadfunc, (void*)i ); 
      tharrey.push_back( threc );
   };
   pause();
   tharrey.erase( tharrey.begin(), tharrey.end() );
   cout << "Clean vector" << endl;
};


