#include <stdlib.h>
#include <stdio.h>
#include <iostream.h>
#include <signal.h>
#include <unistd.h>

static void handler( int signo, siginfo_t* info, void* context ) {
   cout << "received signal " << signo
           << " code = " << info->si_code
           << " val = " << info->si_value.sival_int << endl;
};

int main( int argc, char *argv[] ) {
   cout << "signal SIGRTMIN=" << (int)SIGRTMIN << " - signal SIGRTMAX=" << (int)SIGRTMAX << endl;
   int opt, val, beg = SIGRTMAX, num = 3, fin = SIGRTMAX - num, seq = 3;
   while ( ( opt = getopt( argc, argv, "b:e:n:") ) != -1 ) {
      switch( opt ) {
         case 'b' :
            if( sscanf( optarg, "%i", &val ) != 1 ) perror( "parse command line failed" ), exit( EXIT_FAILURE );
            beg = val;
            break;
         case 'e' :
            if( sscanf( optarg, "%i", &val ) != 1 ) perror( "parse command line failed" ), exit( EXIT_FAILURE );
            fin = val;
            break;
         case 'n' :
            if( sscanf( optarg, "%i", &val ) != 1 ) perror( "parse command line failed" ), exit( EXIT_FAILURE );
            seq = val;
            break;
         default :
            perror( "parse command line failed" ), exit( EXIT_FAILURE );
            break;
      }
   };   
   num = fin - beg;
   fin += num > 0 ? 1 : -1;
   sigset_t sigset;
   sigemptyset( &sigset );
   for( int i = beg; i != fin; i += ( num > 0 ? 1 : -1 ) ) sigaddset( &sigset, i );
   pid_t pid;
   if( pid = fork() == 0 ) {
   // дочерний процесс: здесь сигналы обрабатываются
      sigprocmask( SIG_BLOCK, &sigset, NULL );      
      for( int i = beg; i != fin; i += ( num > 0 ? 1 : -1 ) ) { 
         struct sigaction act, oact;
         sigemptyset( &act.sa_mask );
         act.sa_sigaction = handler;
         act.sa_flags = SA_SIGINFO;		// вот оно - реальное время!         
         if( sigaction( i, &act, NULL ) < 0 ) perror( "set signal handler: " ); 
      };
      cout << "CHILD: signal mask set" << endl;      
      sleep( 3 );								// пауза для отсылки сигналов родителем
      cout << "CHILD: signal unblock" << endl;                  
      sigprocmask( SIG_UNBLOCK, &sigset, NULL );   
      sleep( 3 );								// пауза для получения сигналов       
      exit( EXIT_SUCCESS );
   }
   // родительский процесс: отсюда сигналы посылаются
   sigprocmask( SIG_BLOCK, &sigset, NULL );   
   sleep( 1 );									// пауза для установок дочерним процессом
   union sigval value;
   for( int i = beg; i != fin; i += ( num > 0 ? 1 : -1 ) ) {    
      for( int j = 0; j < seq; j++ ) {
         value.sival_int = j;
         sigqueue( pid, i, value );
         cout << "signal sent: " << i << " with val = " << j << endl;
      };   
   }; 
   cout << "PARENT: finished!" << endl;   
   exit( EXIT_SUCCESS );      
};




        

