#include <stdio.h>
#include <iostream.h>
#include <signal.h>
#include <unistd.h>
#include <pthread.h>
#include <time.h>
#include <sys/neutrino.h>

static void handler( int signo, siginfo_t* info, void* context ) {
   cout << "SIG = " << signo << "; TID = " << pthread_self()  << endl;
};

void* threadfunc ( void* data ) {
   // заблокировать все сигналы
   sigset_t sig; 
   sigfillset( &sig ); 
   SignalProcmask( 0, 0, SIG_BLOCK, &sig, NULL );
   // разблокировать сигнал потока   
   sigemptyset( &sig ); 
   sigaddset( &sig, (int)data );   
   SignalProcmask( 0, 0, SIG_UNBLOCK, &sig, NULL );
   while( true ) pause();
};                    

int main() {
   // единая структура для установки обработчика на все сигналы
   struct sigaction act;
   sigemptyset( &act.sa_mask );
   act.sa_sigaction = handler;
   act.sa_flags = SA_SIGINFO;
   // запуск потоков
   const int thrnum = 3;
   for( int i = SIGRTMIN; i - SIGRTMIN < thrnum; i++ ) {
      sigset_t sig;
      sigemptyset( &sig ); 
      sigaddset( &sig, i );
      sigprocmask( SIG_BLOCK, &sig, NULL );     
      if( sigaction( i, &act, NULL ) < 0 ) perror( "set signal handler: " ); 
      pthread_create( NULL, NULL, threadfunc, (void*)( i ) ); 
   };
   for( int i = 0; ; i++ ) {
      sleep( 1 );
      kill ( getpid(), SIGRTMIN + i % thrnum );
//      union sigval val;
//      val.sival_int = i;      
//      sigqueue( getpid(), SIGRTMIN + i % thrnum, val ); 
   };
};

