#include "common.h"

static uint64_t *tim;
static int num = 10;

static void outtim( void ) {
   double m = 0., s = 0.;
   for( int i = 0; i < num; i++ ) {
      double d = (double)tim[ i ];
      m += d; s += d * d;
   };
   m /= num;
   s = sqrt( s / num - m * m );
   cout << '\t' << (uint64_t)floor( m + .5 ) << "\t~" << (uint64_t)floor( s + .5 )
           << "\t{" << (uint64_t)floor( s / m * 100 + .5 ) << "%}" << endl;
};

int main( int argc, char **argv ) {
   cout << "SRR client: " << VERSION << endl;
   int opt, val;
   unsigned int blk = 100; 
   char PATH[ _POSIX_PATH_MAX ] = "";
   while ( ( opt = getopt( argc, argv, "n:b:m:" ) ) != -1 ) {
      switch( opt ) { 
         case 'n' :
            strcpy( PATH, "/net/" );
            strcat( PATH, optarg );
            break;
         case 'b' :
            if( sscanf( optarg, "%i", &blk ) != 1 ) exit( "parse command line failed" );
            break;
         case 'm' :
            if( sscanf( optarg, "%i", &num ) != 1 ) exit( "parse command line failed" );
            break;
         default :
            perror( "parse command line failed" ), exit( EXIT_FAILURE );
            break;
       }
   };
   strcat( PATH, DEVNAME );
   cout << "server path: " << PATH << ", block size = " << blk
          << " bytes, repeat = " << num << endl;
   result data;
   cout << "CPU speed [c.p.s.]: client = " << data.cps;
   // найти и открыть соответствующий менеджер
   int fd = open( PATH, O_RDONLY );
   if( fd < 0 ) exit( "server not found" ); 
   if( read( fd, &data, sizeof( result ) ) == -1 ) exit( "parameter block read" );
   cout << ", server = " << data.cps << endl;
   tim = new uint64_t[ num ];
   uint64_t tim2;
   uint8_t *bufin = new uint8_t[ blk ], *bufou = new uint8_t[ blk ];   
/*   // время прямого копирования блока
   cout << "- bidirect memory copy:" << flush;
   for( int i = 0; i < num; i++ ) {
      tim[ i ] = ClockCycles();
      memcpy( bufou, bufin, blk );
      tim[ i ] = ( ClockCycles() - tim[ i ] ) * 2;
   }; */
//   outtim();
   // определение дескриптора хоста
   int32_t node = netmgr_strtond( PATH, NULL );
   if( node == -1 && fd > 0 && errno == ENOENT ) node = ND_LOCAL_NODE;
   // обмен посредством низкоуровневых сообщений
   int coid = ConnectAttach( node, data.pid, data.chid, _NTO_SIDE_CHANNEL, 0 );
   if( coid < 0 ) exit( "connect to message channel" );
   cout << "- message exchange:" << flush;
   for( int i = 0; i < num; i++ ) {
      tim[ i ] = ClockCycles();
      if( MsgSend( coid, bufou, blk, bufin, blk ) == -1 ) exit( "exchange data with channel" );
      tim[ i ] = ClockCycles() - tim[ i ];
   };
   outtim();
   ConnectDetach( coid );
   // "конструирование" команды обмена dvctl():
   unsigned int DCTL = ( blk<<16 ) + DCMD_SRR;
   cout << "- menager exchange:" << flush;
   for( int i = 0; i < num; i++ ) {
      tim[ i ] = ClockCycles();
      if( devctl( fd, DCTL, bufou, blk, NULL ) != EOK ) exit( "DEVCTL error" ); 
      tim[ i ] = ClockCycles() - tim[ i ];
   };
   outtim();
   close( fd );
   delete [] bufin, delete [] bufou;   
   delete [] tim;
   return EXIT_SUCCESS;
};

