#include "common.h"

/*


static void outtim( void ) {
   double m = 0., s = 0.;
   for( int i = 0; i < num; i++ ) {
      double d = (double)tim[ i ];
      m += d; s += d * d;
   };
   m /= num;
   s = sqrt( s / num - m * m );
   cout << '\t' << (uint64_t)floor( m + .5 ) << "\t~" << (uint64_t)floor( s + .5 )
           << "\t{" << (uint64_t)floor( s / m * 100 + .5 ) << "%}" << endl;
};
*/

static bool conti = true;
// обработчик сигнала (SIGINT - ^C)
inline static void trap( int signo ) { conti = false; };

int main( int argc, char **argv ) {
   cout << "SRR repeater: " << VERSION << endl;
   int opt, val;
   unsigned int blk = 100; 
   char PATH[ _POSIX_PATH_MAX ] = "";
   bool lowlvl = true;
   while ( ( opt = getopt( argc, argv, "n:b:d" ) ) != -1 ) {
      switch( opt ) { 
         case 'n' :
            strcpy( PATH, "/net/" );
            strcat( PATH, optarg );
            break;
         case 'b' :
            if( sscanf( optarg, "%i", &blk ) != 1 ) exit( "parse command line failed" );
            break;
         case 'd' :
            lowlvl = false;
            break;
         default :
            perror( "parse command line failed" ), exit( EXIT_FAILURE );
            break;
       }
   };
   strcat( PATH, DEVNAME );
   cout << "server path: " << PATH << ", block size = " << blk << " bytes" << endl;
   result data;
   cout << "CPU speed [c.p.s.]: client = " << data.cps;
   uint64_t cps = data.cps;
   // найти и открыть соответствующий менеджер
   int fd = open( PATH, O_RDONLY );
   if( fd < 0 ) exit( "server not found" ); 
   if( read( fd, &data, sizeof( result ) ) == -1 ) exit( "parameter block read" );
   cout << ", server = " << data.cps << endl;
   // определение дескриптора хоста
   int32_t node = netmgr_strtond( PATH, NULL );
   if( node == -1 && fd > 0 && errno == ENOENT ) node = ND_LOCAL_NODE;
   // обмен посредством низкоуровневых сообщений
   int coid = ConnectAttach( node, data.pid, data.chid, _NTO_SIDE_CHANNEL, 0 );
   if( coid < 0 ) exit( "connect to message channel" );
   // "конструирование" команды обмена dvctl():
   unsigned int DCTL = ( blk<<16 ) + DCMD_SRR;
   cout << ". . . . . . waiting  ^C. . . . . ." << flush;
    // переопределить (запретить) ^C
   signal( SIGINT, trap ); 
   uint64_t num = 0;
   uint8_t *bufin = new uint8_t[ blk ], *bufou = new uint8_t[ blk ];  
   uint64_t tim= ClockCycles();
   if( lowlvl )
      while( true ) {
         if( MsgSend( coid, bufou, blk, bufin, blk ) == -1 ) exit( "exchange data with channel" );
         num++;
         if( !conti ) break;
      }
   else {
      while( true ) {
         if( devctl( fd, DCTL, bufou, blk, NULL ) != EOK ) exit( "DEVCTL error" ); 
         num++;
         if( !conti ) break;
      };
   };
   tim = ClockCycles() - tim;
   cout << '\r' << ( lowlvl ? "message exchange:" : "menager exchange:" ) 
           << " number = " << num << "; stream = "
           << (double)num * blk / ( (double)tim / (double)cps ) / 1E6 * 8
           << " Mbit/sec" << endl;
   ConnectDetach( coid );
   close( fd );
   delete [] bufin, delete [] bufou;   
   return EXIT_SUCCESS;
};

