#ifndef COMMON_H
#define COMMON_H

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <inttypes.h>
#include <limits.h>
#include <errno.h>
#include <iostream.h>
#include <sys/neutrino.h>
#include <sys/syspage.h> 
#include <sys/netmgr.h>
#include <fcntl.h>
#include <math.h>
#include <pthread.h>
#include <devctl.h>

const char VERSION[] = "vers. 1.03"; 

// регистрационное имя (префикс) менеджера
static const char DEVNAME[ _POSIX_PATH_MAX ] = "/dev/srr";

// код команды обмена по dvctl()
const unsigned int DCMD_CMD = 1,
                              DCMD_SRR = _POSIX_DEVDIR_TOFROM + ( _DCMD_NET << 8 ) + DCMD_CMD;

// структура, заполняемая по read() с менеджера:
struct result {
   pid_t pid;
   int    chid;
   uint64_t cps;
   result( void ) {
      pid = getpid();
      // частота процессора
      cps = SYSPAGE_ENTRY( qtime )->cycles_per_sec;
   };
};

// завершение по ошибке
inline void exit( const char *msg ) {
   cout << '\r';
   perror( msg ); 
   exit( EXIT_FAILURE );
};

#endif

