#include <stdlib.h>
#include <stdio.h>
#include <iostream.h>
#include <unistd.h>
#include <inttypes.h>
#include <pthread.h>
#include <sys/neutrino.h>
#include <atomic.h>

int main( int argc, char *argv[] ) {
   uint64_t N = 100000;
   bool atom = false, value = false;
   int opt, val; 
   while ( ( opt = getopt( argc, argv, "n:av" ) ) != -1 ) {
      switch( opt ) {
         case 'n' :
            if( sscanf( optarg, "%i", &val ) != 1 )
               cout << "parse command line error" << endl, exit( EXIT_FAILURE );
            if( val > 0 ) N = val;
            break;
         case 'a' :
            atom = true;
            break;
         case 'v' :
            value = true;
            break;
         default :
            cout << "parse command line failed" << endl, exit( EXIT_FAILURE );
            break;
       }
   };
   uint64_t i = N, t = ClockCycles();
   volatile unsigned ind = 0;
   if( !atom ) {
      pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;
      while( i-- ) {
         pthread_mutex_lock( &mutex );
         ind++;
         pthread_mutex_unlock( &mutex );  
      }
   }
   else if( value ) while( i-- ) atomic_add_value( &ind, 1 );
   else while( i-- ) atomic_add( &ind, 1 );
   t = ClockCycles() - t;
   cout << "all cycles - " << t << "; on operation - " << t / N << endl;
   exit( EXIT_SUCCESS );
};

