#include <stdlib.h>
#include <iostream.h>
#include <sys/syspage.h> 
#include <inttypes.h>
#include <unistd.h>
#include <sys/neutrino.h>
//#include <pthread.h>
#include <list>

typedef int element;

class dbase : public list<element> {
   static const int READ_DELAY = 1, WRITE_DELAY = 2;
public:
   void add( const element& e ) {
      int pos = size() * rand() / RAND_MAX;
      list<element>::iterator p = begin();
      for( int i = 0; i < pos; i++ ) p++;
      insert( p, e );
      delay( WRITE_DELAY );
   };
   int pos( const element& e ) {
      int n = 0;
      for( list<element>::iterator i = begin(); i != end(); i++, n++ ) 
         if( *i == e ) { delay( READ_DELAY ); break; };
      if( n == size() )  n = -1;
      return n;
   };
} data;

inline element erand( unsigned long n ) { return (element)( ( n * rand() ) / RAND_MAX ); };
inline bool wrand( double p ) { return (double)rand() / (double)RAND_MAX < p; };

int main( int argc, char *argv[] ) {
   static unsigned long n = 1000;           // число обращений к базе данных
   static double p = .1;                            // частота операций обновления базы данных
   unsigned long m;
   if( argc > 1 && ( m = atoll( argv[ 1 ] ) ) != 0 ) n = m;
   double q;
   if( argc > 2 && ( q = atof( argv[ 2 ] ) ) != 0 ) p = q;
   for( int i = 0; i < n; i++ ) data.add( erand( n ) );
   const uint64_t cps = SYSPAGE_ENTRY( qtime )->cycles_per_sec;  // частота процессора:   
   uint64_t t = ClockCycles();
   for( int i = 0; i < n; i++ ) {
      element e = erand( n );
      if( !wrand( p ) ) data.pos( e );
      else data.add( e );
   };
   t = ( ( ClockCycles() - t ) * 1000000000 ) / cps;;
   cout << "evaluation time: " << (double)t / 1.E9 << " sec." << endl;
   return EXIT_SUCCESS;
};

