#include <stdlib.h>
#include <stdio.h>
#include <iostream.h>
#include <unistd.h>
#include <pthread.h>
#include <errno.h>
#include <semaphore.h>
#include <atomic.h>

const int D = 10;
unsigned int T = 2;
static sem_t sem;
pthread_t* tid;

void* writer ( void* data ) {
   unsigned long i = (int)(data);
   unsigned int s = 1;
   while( i-- > 0 ) {
      delay( (long)rand_r( &s ) * D / RAND_MAX + 1 );
      sem_post( &sem );
   };
   for( i = 0; i < T; i++ ) pthread_cancel( tid[ i + 1 ] );
   return NULL;
};

static char *str;
static volatile unsigned ind = 0;

void* reader ( void* ) {
   char tid[ 8 ];
   sprintf( tid, "%X", pthread_self() ); 
   unsigned int s = rand(); 
   pthread_setcanceltype( PTHREAD_CANCEL_DEFERRED, NULL );   
   while( true ) {
      sem_wait( &sem );
      str[ atomic_add_value( &ind, 1 ) ] = *tid; 
      pthread_testcancel();  
      delay( (long)rand_r( &s ) * D * T / RAND_MAX + 1 );
   };
   return NULL;
};

int main( int argc, char *argv[] ) {
   unsigned long N = 1000;
   int opt, val; 
   while ( ( opt = getopt( argc, argv, "n:t:" ) ) != -1 ) {
      switch( opt ) {
         case 'n' :
            if( sscanf( optarg, "%i", &val ) != 1 )
               cout << "parse command line error" << endl, exit( EXIT_FAILURE );
            if( val > 0 ) N = val;
            break;
         case 't' :
            if( sscanf( optarg, "%i", &val ) != 1 )
               cout << "parse command line error" << endl, exit( EXIT_FAILURE );
            if( val > 0 ) T = val;
            break;
         default :
            cout << "parse command line failed" << endl, exit( EXIT_FAILURE );
            break;
       }
   };
   str = new char[ N + 1 ];
   tid = new pthread_t[ T + 1 ];
   if( sem_init( &sem, 0, 0 ) ) perror( "semaphore init" ), exit( EXIT_FAILURE );
   if( pthread_create( tid, NULL, writer, (void*)N ) != EOK )
      perror( "writer create error" ), exit( EXIT_FAILURE );
   for( int i = 0; i < T; i++ ) if( pthread_create( tid + i + 1, NULL, reader, NULL ) != EOK )
      perror( "reader create error" ), exit( EXIT_FAILURE );
   for( int i = 0; i < T; i++ ) pthread_join( tid[ i ], NULL );
   sem_destroy( &sem );
   delete [] tid;
   str[ ind ] = '\0';
   cout << str << endl;
   delete [] str;
   exit( EXIT_SUCCESS );
};

